/// <reference types="zen-observable" />
import { ApolloLink, Operation, GraphQLRequest, FetchResult, Observable } from "@apollo/client";
export declare type ResultFunction<T> = () => T;
export interface OperationNameMockedResponse<TData = Record<string, any>> {
    request: Pick<GraphQLRequest, "operationName"> & Partial<GraphQLRequest>;
    result?: FetchResult<TData> | ResultFunction<FetchResult<TData>>;
    error?: Error;
    delay?: number;
    newData?: ResultFunction<FetchResult>;
}
export declare class OperationNameMockLink extends ApolloLink {
    operation: Operation;
    addTypename: Boolean;
    private mockedResponsesByKey;
    constructor(mockedResponses: ReadonlyArray<OperationNameMockedResponse>, addTypename?: Boolean);
    addMockedResponse(mockedResponse: OperationNameMockedResponse): void;
    request(operation: Operation): Observable<FetchResult> | null;
    private normalizeMockedResponse;
}
export interface MockApolloLink extends ApolloLink {
    operation?: Operation;
}
export declare function mockSingleLink(...mockedResponses: Array<any>): MockApolloLink;
//# sourceMappingURL=mockLink.d.ts.map